(define-constant +bigreq-opcode+ 128)

(define-constant +extensions+   ; format :  (("name1" opcode1 first-event1 first-error1) ("name12 opcode2 first-event2 first-error2) ...) 
  `(("BIG-REQUESTS" ,+bigreq-opcode+ 0 0)))

(define-constant +request-opcodes+ 
'(
  (1  . :CreateWindow)
  (2  . :ChangeWindowAttributes)
  (3  . :GetWindowAttributes)
  (4  . :DestroyWindow)
  (5  . :DestroySubwindows)
  (6  . :ChangeSaveSet)
  (7  . :ReparentWindow)
  (8  . :MapWindow)
  (9  . :MapSubwindows)
  (10 . :UnmapWindow)
  (11 . :UnmapSubwindows)
  (12 . :ConfigureWindow)
  (13 . :CirculateWindow)
  (14 . :GetGeometry)
  (15 . :QueryTree)
  (16 . :InternAtom)
  (17 . :GetAtomName)
  (18 . :ChangeProperty)
  (19 . :DeleteProperty)
  (20 . :GetProperty)
  (21 . :ListProperties)
  (22 . :SetSelectionOwner)
  (23 . :GetSelectionOwner)
  (24 . :ConvertSelection)
  (25 . :SendEvent)
  (26 . :GrabPointer)
  (27 . :UngrabPointer)
  (28 . :GrabButton)
  (29 . :UngrabButton)
  (30 . :ChangeActivePointerGrab)
  (31 . :GrabKeyboard)
  (32 . :UngrabKeyboard)
  (33 . :GrabKey)
  (34 . :UngrabKey)
  (35 . :AllowEvents)
  (36 . :GrabServer)
  (37 . :UngrabServer)
  (38 . :QueryPointer)
  (39 . :GetMotionEvents)
  (40 . :TranslateCoordinates)
  (41 . :WarpPointer)
  (42 . :SetInputFocus)
  (43 . :GetInputFocus)
  (45 . :OpenFont)
  (46 . :CloseFont)
  (47 . :QueryFont)
  (48 . :QueryTextExtents)
  (49 . :ListFonts)
  (50 . :ListFontsWithInfo)
  (51 . :SetFontPath)
  (52 . :GetFontPath)
  (53 . :CreatePixmap)
  (54 . :FreePixmap)
  (55 . :CreateGC)
  (56 . :ChangeGC)
  (57 . :CopyGC)
  (58 . :SetDashes)
  (59 . :SetClipRectangles)
  (60 . :FreeGC)
  (61 . :ClearArea)
  (62 . :CopyArea)
  (63 . :CopyPlane)
  (64 . :PolyPoint)
  (65 . :PolyLine)
  (66 . :PolySegment)
  (67 . :PolyRectangle)
  (68 . :PolyArc)
  (69 . :FillPoly)
  (70 . :PolyFillRectangle)
  (71 . :PolyFillArc)
  (72 . :PutImage)
  (73 . :GetImage)
  (74 . :PolyText8)
  (75 . :PolyText16)
  (76 . :ImageText8)
  (77 . :ImageText16)
  (78 . :CreateColormap)
  (79 . :FreeColormap)
  (80 . :CopyColormapAndFree)
  (81 . :InstallColormap)
  (82 . :UninstallColormap)
  (83 . :ListInstalledColormaps)
  (84 . :AllocColor)
  (85 . :AllocNamedColor)
  (86 . :AllocColorCells)
  (87 . :AllocColorPlanes)
  (88 . :FreeColors)
  (89 . :StoreColors)
  (90 . :StoreNamedColor)
  (91 . :QueryColors)
  (92 . :LookupColor)
  (93 . :CreateCursor)
  (94 . :CreateGlyphCursor)
  (95 . :FreeCursor)
  (96 . :RecolorCursor)
  (97 . :QueryBestSize)
  (98 . :QueryExtension)
  (99 . :ListExtensions)
  (100 . :ChangeKeyboardMapping)
  (101 . :GetKeyboardMapping)
  (102 . :ChangeKeyboardControl)
  (103 . :GetKeyboardControl)
  (104 . :Bell)
  (105 . :ChangePointerControl)
  (107 . :SetScreenSaver)
  (108 . :GetScreensaver)
  (109 . :ChangeHosts)
  (110 . :ListHosts)
  (111 . :SetAccessControl)
  (112 . :SetCloseDownMode)
  (113 . :KillClient)
  (114 . :RotateProperties)
  (115 . :ForceScreenSaver)
  (116 . :SetPointerMapping)
  (117 . :GetPointerMapping)
  (118 . :SetModifierMapping)
  (119 . :GetModifierMapping)
  (127 . :NoOperation)
  
)) ; (define-constant +request-opcodes+ '(

(define-constant +ext-request-opcodes+
    '(
      (#.+bigreq-opcode+ . ((0 . :BigReqEnable)))))

(defun major-opcode (request)
  (or (first (rassoc request
		     +request-opcodes+))
      (first (find request
		   +ext-request-opcodes+
		   :test #'(lambda (request entry)
			     (rassoc request 
				     (rest entry)))))))

(defun minor-opcode (request)
  (or (first (rassoc request
		     (rest (assoc (major-opcode request)
				  +ext-request-opcodes+))))
      0))
  
;; TODO : generate a reverse table request->opcode at compile time, for faster major-opcode and minor-opcode